/*
 **
 ** Copyright 2019 Karlsruhe Institute of Technology, Chair of Dependable Nano Computing
 **
 ** Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 ** and associated documentation files (the "Software"), to deal in the Software without restriction, 
 ** including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
 ** and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do 
 ** so, subject to the following conditions:
 **
 ** The above copyright notice and this permission notice shall be included in all copies or substantial 
 ** portions of the Software.
 **
 ** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT 
 ** LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
 ** IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 
 ** WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 ** SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 **
 */
 
module debounce (clkin, asynchin, synchout);
	input clkin;
	input asynchin;
	output synchout;
	reg synchout = 1'b0;
	reg [7:0] counter = 8'b0;
	
	always @( posedge clkin ) begin
		if (counter == 8'b11111111) begin
			synchout <= 1'b1;
		end else if (counter == 8'b0) begin
			synchout <= 1'b0;
		end
	end
	always @( posedge clkin ) begin
		if ((asynchin == 1'b1) && (counter < 8'b11111111)) begin
			counter <= counter + 1'b1;
		end else if (counter > 8'b0) begin
			counter <= counter - 1'b1;
		end
	end

endmodule


